local T, C, L, _ = unpack(select(2, ...))
if C.chat.enable ~= true then return end

----------------------------------------------------------------------------------------
--	Systems spam filter
----------------------------------------------------------------------------------------
if C.chat.filter == true then
	ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_SAY", function() if IsResting() then return true end end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_YELL", function() if IsResting() then return true end end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_JOIN", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_LEAVE", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_AFK", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_DND", function() return true end)
	DUEL_WINNER_KNOCKOUT = ""
	DUEL_WINNER_RETREAT = ""
	DRUNK_MESSAGE_ITEM_OTHER1 = ""
	DRUNK_MESSAGE_ITEM_OTHER2 = ""
	DRUNK_MESSAGE_ITEM_OTHER3 = ""
	DRUNK_MESSAGE_ITEM_OTHER4 = ""
	DRUNK_MESSAGE_OTHER1 = ""
	DRUNK_MESSAGE_OTHER2 = ""
	DRUNK_MESSAGE_OTHER3 = ""
	DRUNK_MESSAGE_OTHER4 = ""
	DRUNK_MESSAGE_ITEM_SELF1 = ""
	DRUNK_MESSAGE_ITEM_SELF2 = ""
	DRUNK_MESSAGE_ITEM_SELF3 = ""
	DRUNK_MESSAGE_ITEM_SELF4 = ""
	DRUNK_MESSAGE_SELF1 = ""
	DRUNK_MESSAGE_SELF2 = ""
	DRUNK_MESSAGE_SELF3 = ""
	DRUNK_MESSAGE_SELF4 = ""
	ERR_PET_LEARN_ABILITY_S = ""
	ERR_PET_LEARN_SPELL_S = ""
	ERR_PET_SPELL_UNLEARNED_S = ""
	ERR_LEARN_ABILITY_S = ""
	ERR_LEARN_SPELL_S = ""
	ERR_LEARN_PASSIVE_S = ""
	ERR_SPELL_UNLEARNED_S = ""
	CREATED_ITEM = ""
	CREATED_ITEM_MULTIPLE = ""

	-- Prevent empty line
	local function systemFilter(_, _, text)
		if text and text == "" then
			return true
		end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", systemFilter)
end

----------------------------------------------------------------------------------------
--	Players spam filter(by Evl, Elv22 and Affli)
----------------------------------------------------------------------------------------
if C.chat.spam == true then
	-- Repeat spam filter
	local NameHash = {}
	local MSGCache = {}
	local RepInterval = 40

	local function utf8bytes(bs,offset)
	    local b = bs[offset]
	    if b < 128 then
	        return 1
	    end

	    if b <= 192 then  --非法utf8序列
	        return 0
	    end
	    local bvs = {128,64,32,16,8,4}
	    for i = 1, #bvs do
	        b = b - bvs[i]
	        if b < 0 then
	            return i - 1
	        end
	    end

	    return 0
	end

	--字符串拆成字数组
	local function bff_msg_split(msg)
	    local bs = {string.byte(msg, 1, -1)}
	    local i = 1
	    local arr = {}
	    while i <= #bs do
	        local n = utf8bytes(bs,i)
	        if n == 0 then
	            return nil
	        end
	        --物品链接作为一个整体
	        --非物品链接的彩色文字，颜色标识单独提取出来
	        --物品链接基本样式：|cffaabbcc|Hitem::::::::::::::|h[]|h|r
	        local item_link = false
	        if n == 1 and (#bs - i) > 12 and bs[i] == 0x7c and bs[i + 1]==0x63 then  --|c开头，物品链接或彩色文字
	            local start = i + 10
	            local color = true
	            for j = i + 2, i + 9 do
	                if bs[j] < 48 then
	                    color = false
	                    break
	                elseif bs[j] > 57 and bs[j] < 65 then
	                    color = false
	                    break
	                elseif bs[j] > 70 and bs[j] < 97 then
	                    color = false
	                    break
	                elseif bs[j] > 102 then
	                    color = false
	                    break
	                end
	            end

	            if not color then
	                table.insert(arr, '|c')
	                i = i + 2
	            else
	                if string.sub(msg, i + 10, i + 15) =='|Hitem' then
	                    start = i + 16
	                    item_link = true
	                end
	                local end_idx = 0

	                for j = start, #bs - 1 do
	                    if end_idx > 0 then
	                        break
	                    end
	                    if bs[j] == 0x7c and bs[j + 1] == 0x72 then --结束|r
	                        end_idx = j
	                    end
	                end
	                if end_idx > 0 then
	                    if item_link then   --物品链接作为一个整体
	                        table.insert(arr, string.sub(msg, i, end_idx + 1))
	                        i = end_idx + 2
	                    else -- 颜色标识符作为一个整体(实际上聊天信息不能单独设置颜色，只能配合物品链接使用？)
	                        table.insert(arr, string.sub(msg, i, i + 9))
	                        i = i + 10
	                    end
	                else
	                    table.insert(arr, string.sub(msg, i, i + 9))
	                    i = i + 10
	                end
	            end
	        --elseif n==1 and (#bs-i)>12 and bs[i] == 0x7c and bs[i+1]==0x72 then --物品链接、颜色结束符
	         --   table.insert(arr,'|')
	         --   table.insert(arr,'r')
	         --   i = i+2
	        else
	            table.insert(arr, string.sub(msg, i, i + n - 1))
	            i = i + n
	        end
	    end

	    return arr
	end

	local function is_symbol(c)
	    local cv = string.byte(c)
	    if not cv then
	        return false
	    end
	    if cv < 48 then
	        return true
	    end

	    if cv > 57 and cv < 65 then
	        return true
	    end

	    if cv > 90 and cv < 97 then
	        return true
	    end

	    if cv > 122 and cv < 128 then
	        return true
	    end

	    return false
	end
	--叠字过滤
	local function trim_rchars(cs)
	    local _cs = {}
	    local lastc = ''
	    local rn = 0
	    local force = false
	    for _, c in ipairs(cs) do
	        if force then
	            lastc = c
	            table.insert(_cs, c)
	        elseif string.byte(c) >= 48 and string.byte(c) <= 57 then --数字不处理
	            lastc = c
	            table.insert(_cs, c)
	        elseif lastc == '|' and c == 'c' then --颜色表达式(|cffff0000 |r)的处理
	            lastc = c
	            table.insert(_cs, c)
	            force = true
	        elseif lastc == '|' and c == 'r' then
	            lastc = c
	            table.insert(_cs, c)
	            force = false
	        elseif lastc ~= c then
	            rn = 1
	            if is_symbol(lastc) and c == ' ' then
	                --符号后面的空格直接不要
	            else
	                rn = 0
	                lastc = c
	                table.insert(_cs, c)
	            end
	        else
	            rn = rn + 1
	            if rn < 3 then
	                --数字、字母、中文留两个
	                if not is_symbol(c) then
	                    table.insert(_cs, c)
	                end
	            end
	        end
	    end

	    return _cs
	end

	--叠句过滤
	local function trim_rsentence(cs)
	    local total = #cs
	    if total < 15 then
	        return cs
	    end

	    local fin = false
	    for i = 10, total - 10 do
	        if fin then
	            break
	        end
	        local nm = 0
	        local start = 1
	        for j = 1,total - 10 do
	            if fin then
	                break
	            end
	            if cs[j] == cs[i + j] then
	                nm = nm + 1
	            else
	                if nm > 4 then
	                    for k = 1, nm do
	                        table.remove(cs, i + start)
	                    end
	                    fin = true
	                end
	                start = j + 1
	                nm = 0
	            end
	        end
	    end

	    return cs
	end

	local bfwf_trim_message = function(msg)
	    if not msg then
	        return 0, msg
	    end

	    local cs = bff_msg_split(msg)
	    if not cs then
	        return 0, msg
	    end

	    local len = #cs
	    local cs1 = trim_rchars(cs)
	    local n = #cs1
	    local cs2 = trim_rsentence(cs1)
	    while n ~= #cs2 do
	        n = #cs2
	        cs2 = trim_rsentence(cs2)
	    end

	    if #cs == #cs2 then
	        return 0, msg
	    end

	    if #cs1 ~= #cs2 then    --叠句过滤后可能会产生叠字
	        cs2 = trim_rchars(cs2)
	    end

	    return (len - #cs2), table.concat(cs2)
	end

	local function ChatMessageFilter(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, line, arg12, arg13, arg14, ...)
		local sender = Ambiguate(arg2, 'none')
		if sender == T.name then
			return false
		end
		if arg6 == "DND" or arg6 == "AFK" then
    		return true
    	end
		if NameHash[sender] then
			return true
		end
		if MSGCache[sender] and time() - MSGCache[sender] >= RepInterval then
			MSGCache[sender] = nil
		end
		if MSGCache[sender] then
			return true
		end
		local msg = strtrim(arg1)
		if #T.ChatBlockList > 0 then
			for index = 1, #T.ChatBlockList do
				if strmatch(sender, T.ChatBlockList[index]) ~= nil then
					NameHash[sender] = true
					return true
				end
			end
		end
		if #T.ChatSpamList > 0 then
			for index = 1, #T.ChatSpamList do
				if strmatch(msg, T.ChatSpamList[index]) ~= nil then
					NameHash[sender] = true
					return true
				elseif strmatch(sender, T.ChatSpamList[index]) ~= nil then
					NameHash[sender] = true
					return true
				end
			end
		end
		local filtered, new = bfwf_trim_message(msg)
		if filtered > 0 then
			MSGCache[sender] = time()
			return false, new, sender, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, line, arg12, arg13, arg14, ...
		end
		MSGCache[sender] = time()
		return false
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", ChatMessageFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", ChatMessageFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ChatMessageFilter)
	
	if IsAddOnLoaded("ShestakUI_Config") then
		UnitPopupButtons["BLOCK"] = {text = IGNORE_PLAYER, }
		tinsert(UnitPopupMenus["FRIEND"], 9, "BLOCK")

		hooksecurefunc("UnitPopup_OnClick", function(self)
	    	local name = UIDROPDOWNMENU_INIT_MENU.name
	    	local IGNORE_ADDED = format(ERR_IGNORE_ADDED_S,name)
	    	if (self.value == "BLOCK") then
			    if not C.options["chat"] then
					C.options["chat"] = {}
				end	
				if not C.options["chat"]["ChatBlock_list"] then
					C.options["chat"]["ChatBlock_list"] = T.ChatBlockList
				end	
	        	tinsert(C.options.chat.ChatBlock_list, name)
	        	NameHash[name] = true
	        	SendSystemMessage(IGNORE_ADDED)
	    	end
		end)
	end
end
